#!/usr/bin/perl
my $VMWARE = "/usr/bin/vmware-cmd";
if ( $ARGV[0] eq "autoconf" ){
    print "yes\n";
    exit;   
}

if ( $ARGV[0] eq "config" ){
    print "graph_title CPU jiffies used in kernel mode by virtual machines\n";
    print "graph_vlabel SJiffies\n";
    print "graph_info Individual number of jiffies used in kernel mode by each VMware Server instance.\n";
    print "graph_category VMware\n";
    my @VMS = `$VMWARE -l`;

    my $vm;
    foreach $vm (@VMS){
	chomp $vm;

	my $name = getVMName($vm);
	my $shortname = $name;
	$shortname =~ s/\s+//g;
	$shortname =~ s/-//g;
	$shortname =~ s/\./_/g;
	$name =~ s/\./ /g;
	print "$shortname.label $name\n";
    }
#    print "secs.label secs\n";
    exit;
}



my @VMS = `$VMWARE -l`;

my $vm;
foreach $vm (@VMS){
    chomp $vm;
    my $name = getVMName($vm);
    
    # check if VM is up
    my $result = `$VMWARE '$vm' getstate`;
    my $shortname = $name;
    $shortname =~ s/\s+//g;
    $shortname =~ s/-//g;
    $shortname =~ s/\./_/g;
    if ( $result eq "getstate() = on\n" ){
	my $pid = `$VMWARE '$vm' getpid`;
	$pid =~ s/getpid\(\) = (\d+)\n/$1/g;
#	print "pid: $pid\n";
	open(STATE,"/proc/$pid/stat");
	my @stat = split /\s+/,<STATE>;
	close(STATE);
	my $temp;
	if (stat("/tmp/munin-node.sjiffies.$shortname")){
	    open(TEMP,"/tmp/munin-node.sjiffies.$shortname");
	    $temp = <TEMP>;
	    chomp($temp);
	    close(TEMP);
	}
	if ( $temp and $temp < $stat[14] ){
	    print "$shortname.value " . ( $stat[14] - $temp) . "\n";
	} else {
	    print "$shortname.value " . ( $stat[14] ) . "\n";
	}
	open(TEMP,">/tmp/munin-node.sjiffies.$shortname");
	print TEMP "$stat[14]\n";
	chomp($temp);
	close(TEMP);

    } else {
	print "$shortname.value 0\n";
    }
}

sub getVMName {
    my $vm = $_[0];
    open(VMX,"$vm");
    foreach (<VMX>){

	if ($_ =~ /displayName\s+=\s+\"(.*)\"/ ){
	    close(VMX);
	    return $1;
	}	
    }
    close(VMX);
}